.\".if n .pl 1000i
.de XX
.pl 1v
..
.em XX
.\".nr PI 0
.\".if t .nr PD .5v
.\".if n .nr PD 1v
.nr lu 0
.de CW
.nr PQ \\n(.f
.if t .ft CW
.ie ^\\$1^^ .if n .ul 999
.el .if n .ul 1
.if t .if !^\\$1^^ \&\\$1\f\\n(PQ\\$2
.if n .if \\n(.$=1 \&\\$1
.if n .if \\n(.$>1 \&\\$1\c
.if n .if \\n(.$>1 \&\\$2
..
.ds [. \ [
.ds .] ]
.\"----------------------------------------
.TL
Why the Unix Philosophy still matters
.AU
markus schnalke <meillo@marmaro.de>
.AB
.ti \n(.iu
This paper discusses the importance of the Unix Philosophy in software design.
Today, few software designers are aware of these concepts,
and thus most modern software is limited and does not make use of software leverage.
Knowing and following the tenets of the Unix Philosophy makes software more valuable.
.AE

.\".if t .2C

.FS
.ps -1
This paper was prepared for the seminar ``Software Analysis'' at University Ulm.
Mentor was professor Schweiggert. 2010-02-05
.br
You may get this document from my website
.CW \s-1http://marmaro.de/docs
.FE

.NH 1
Introduction
.LP
Building a software is a process from an idea of the purpose of the software
to its release.
No matter \fIhow\fP the process is run, two things are common:
the initial idea and the release.
The process in between can be of any shape.
The the maintenance work after the release is ignored for the moment.
.PP
The process of building splits mainly in two parts:
the planning of what and how to build, and implementing the plan by writing code.
This paper focuses on the planning part \(en the designing of the software.
.PP
Software design is the plan of how the internals and externals of the software should look like,
based on the requirements.
This paper discusses the recommendations of the Unix Philosophy about software design.
.PP
The here discussed ideas can get applied by any development process.
The Unix Philosophy does recommend how the software development process should look like,
but this shall not be of matter here.
Similar, the question of how to write the code is out of focus.
.PP
The name ``Unix Philosophy'' was already mentioned several times, but it was not explained yet.
The Unix Philosophy is the essence of how the Unix operating system and its toolchest was designed.
It is no limited set of rules, but what people see to be common to typical Unix software.
Several people stated their view on the Unix Philosophy.
Best known are:
.IP \(bu
Doug McIlroy's summary: ``Write programs that do one thing and do it well.''
.[
%A M. D. McIlroy
%A E. N. Pinson
%A B. A. Taque
%T UNIX Time-Sharing System Forward
%J The Bell System Technical Journal
%D 1978
%V 57
%N 6
%P 1902
.]
.IP \(bu
Mike Gancarz' book ``The UNIX Philosophy''.
.[
%A Mike Gancarz
%T The UNIX Philosophy
%D 1995
%I Digital Press
.]
.IP \(bu
Eric S. Raymond's book ``The Art of UNIX Programming''.
.[
%A Eric S. Raymond
%T The Art of UNIX Programming
%D 2003
%I Addison-Wesley
%O .CW \s-1http://www.faqs.org/docs/artu/
.]
.LP
These different views on the Unix Philosophy have much in common.
Especially, the main concepts are similar for all of them.
But there are also points on which they differ.
This only underlines what the Unix Philosophy is:
A retrospective view on the main concepts of Unix software;
especially those that were successful and unique to Unix.
.\" really?
.PP
Before we will have a look at concrete concepts,
we discuss why software design is important
and what problems bad design introduces.


.NH 1
Importance of software design in general
.LP
Why should we design software at all?
It is general knowledge, that even a bad plan is better than no plan.
Ignoring software design is programming without a plan.
This will lead pretty sure to horrible results.
.PP
The design of a software is its internal and external shape.
The design talked about here has nothing to do with visual appearance.
If we see a program as a car, then its color is of no matter.
Its design would be the car's size, its shape, the number and position of doors,
the ratio of passenger and cargo transport, and so forth.
.PP
A software's design is about quality properties.
Each of the cars may be able to drive from A to B,
but it depends on its properties whether it is a good car for passenger transport or not.
It also depends on its properties if it is a good choice for a rough mountain area.
.PP
Requirements to a software are twofold: functional and non-functional.
Functional requirements are easier to define and to verify.
They are directly the software's functions.
Functional requirements are the reason why software gets written.
Someone has a problem and needs a tool to solve it.
Being able to solve the problem is the main functional requirement.
It is the driving force behind all programming effort.
.PP
On the other hand, there are also non-functional requirements.
They are called \fIquality\fP requirements, too.
The quality of a software is about properties that are not directly related to
the software's basic functions.
Quality aspects are about the properties that are overlooked at first sight.
.PP
Quality is of few matter when the software gets initially built,
but it will be of matter in usage and maintenance of the software.
A short-sighted might see in developing a software mainly building something up.
Reality shows, that building the software the first time is only a small amount
of the overall work.
Bug fixing, extending, rebuilding of parts \(en short: maintenance work \(en
does soon take over the major part of the time spent on a software.
Not to forget the usage of the software.
These processes are highly influenced by the software's quality.
Thus, quality should never be neglected.
The problem is that you hardly ``stumble over'' bad quality during the first build,
but this is the time when you should care about good quality most.
.PP
Software design is not about the basic function of a software;
this requirement will get satisfied anyway, as it is the main driving force behind the development.
Software design is about quality aspects of the software.
Good design will lead to good quality, bad design to bad quality.
The primary functions of the software will be affected modestly by bad quality,
but good quality can provide a lot of additional gain from the software,
even at places where one never expected it.
.PP
The ISO/IEC 9126-1 standard, part 1,
.[
%I International Organization for Standardization
%T ISO Standard 9126: Software Engineering \(en Product Quality, part 1
%C Geneve
%D 2001
.]
defines the quality model as consisting out of:
.IP \(bu
.I Functionality
(suitability, accuracy, inter\%operability, security)
.IP \(bu
.I Reliability
(maturity, fault tolerance, recoverability)
.IP \(bu
.I Usability
(understandability, learnability, operability, attractiveness)
.IP \(bu
.I Efficiency
(time behavior, resource utilization)
.IP \(bu
.I Maintainability
(analysability, changeability, stability, testability)
.IP \(bu
.I Portability
(adaptability, installability, co-existence, replaceability)
.LP
These goals are parts of a software's design.
Good design can give these properties to a software,
bad designed software will miss them.
.PP
One further goal of software design is consistency.
Consistency eases understanding, working on, and using things.
Consistent internals and consistent interfaces to the outside can be provided by good design.
.PP
We should design software because good design avoids many problems during a software's lifetime.
And we should design software because good design can offer much gain,
that can be unrelated to the software main intend.
Indeed, we should spend much effort into good design to make the software more valuable.
The Unix Philosophy shows how to design software well.
It offers guidelines to achieve good quality and high gain for the effort spent.


.NH 1
The Unix Philosophy
.LP
The origins of the Unix Philosophy were already introduced.
This chapter explains the philosophy, oriented on Gancarz,
and shows concrete examples of its application.

.NH 2
Pipes
.LP
Following are some examples to demonstrate how applied Unix Philosophy feels like.
Knowledge of using the Unix shell is assumed.
.PP
Counting the number of files in the current directory:
.DS I 2n
.CW
.ps -1
ls | wc -l
.DE
The
.CW ls
command lists all files in the current directory, one per line,
and
.CW "wc -l
counts the number of lines.
.PP
Counting the number of files that do not contain ``foo'' in their name:
.DS I 2n
.CW
.ps -1
ls | grep -v foo | wc -l
.DE
Here, the list of files is filtered by
.CW grep
to remove all that contain ``foo''.
The rest is the same as in the previous example.
.PP
Finding the five largest entries in the current directory.
.DS I 2n
.CW
.ps -1
du -s * | sort -nr | sed 5q
.DE
.CW "du -s *
returns the recursively summed sizes of all files
\(en no matter if they are regular files or directories.
.CW "sort -nr
sorts the list numerically in reverse order.
Finally,
.CW "sed 5q
quits after it has printed the fifth line.
.PP
The presented command lines are examples of what Unix people would use
to get the desired output.
There are also other ways to get the same output.
It's a user's decision which way to go.
.PP
The examples show that many tasks on a Unix system
are accomplished by combining several small programs.
The connection between the single programs is denoted by the pipe operator `|'.
.PP
Pipes, and their extensive and easy use, are one of the great
achievements of the Unix system.
Pipes between programs have been possible in earlier operating systems,
but it has never been a so central part of the concept.
When, in the early seventies, Doug McIlroy introduced pipes for the
Unix system,
``it was this concept and notation for linking several programs together
that transformed Unix from a basic file-sharing system to an entirely new way of computing.''
.[
%T Unix: An Oral History
%O .CW \s-1http://www.princeton.edu/~hos/frs122/unixhist/finalhis.htm
.] 
.PP
Being able to specify pipelines in an easy way is,
however, not enough by itself.
It is only one half.
The other is the design of the programs that are used in the pipeline.
They have to interfaces that allows them to be used in such a way.

.NH 2
Interface design
.LP
Unix is, first of all, simple \(en Everything is a file.
Files are sequences of bytes, without any special structure.
Programs should be filters, which read a stream of bytes from ``standard input'' (stdin)
and write a stream of bytes to ``standard output'' (stdout).
.PP
If the files \fIare\fP sequences of bytes,
and the programs \fIare\fP filters on byte streams,
then there is exactly one standardized data interface.
Thus it is possible to combine them in any desired way.
.PP
Even a handful of small programs will yield a large set of combinations,
and thus a large set of different functions.
This is leverage!
If the programs are orthogonal to each other \(en the best case \(en
then the set of different functions is greatest.
.PP
Programs might also have a separate control interface,
besides their data interface.
The control interface is often called ``user interface'',
because it is usually designed to be used by humans.
The Unix Philosophy discourages to assume the user to be human.
Interactive use of software is slow use of software,
because the program waits for user input most of the time.
Interactive software requires the user to be in front of the computer
all the time.
Interactive software occupy the user's attention while they are running.
.PP
Now we come back to the idea of using several small programs, combined,
to have a more specific function.
If these single tools would all be interactive,
how would the user control them?
It is not only a problem to control several programs at once if they run at the same time,
it also very inefficient to have to control each of the single programs
that are intended to work as one large program.
Hence, the Unix Philosophy discourages programs to demand interactive use.
The behavior of programs should be defined at invocation.
This is done by specifying arguments (``command line switches'') to the program call.
Gancarz discusses this topic as ``avoid captive user interfaces''.
.[
%A Mike Gancarz
%T The UNIX Philosophy
%I Digital Press
%D 1995
%P 88 ff.
.]
.PP
Non-interactive use is, during development, also an advantage for testing.
Testing of interactive programs is much more complicated,
than testing of non-interactive programs.

.NH 2
The toolchest approach
.LP
A toolchest is a set of tools.
Instead of having one big tool for all tasks, one has many small tools,
each for one task.
Difficult tasks are solved by combining several of the small, simple tools.
.PP
The Unix toolchest \fIis\fP a set of small, (mostly) non-interactive programs
that are filters on byte streams.
They are, to a large extend, unrelated in their function.
Hence, the Unix toolchest provides a large set of functions
that can be accessed by combining the programs in the desired way.
.PP
There are also advantages for developing small toolchest programs.
It is easier and less error-prone to write small programs.
It is also easier and less error-prone to write a large set of small programs,
than to write one large program with all the functionality included.
If the small programs are combinable, then they offer even a larger set
of functions than the single large program.
Hence, one gets two advantages out of writing small, combinable programs.
.PP
There are two drawbacks of the toolchest approach.
First, one simple, standardized, unidirectional interface has to be sufficient.
If one feels the need for more ``logic'' than a stream of bytes,
then a different approach might be of need.
But it is also possible, that he just can not imagine a design where
a stream of bytes is sufficient.
By becoming more familiar with the ``Unix style of thinking'',
developers will more often and easier find simple designs where
a stream of bytes is a sufficient interface.
.PP
The second drawback of a toolchest affects the users.
A toolchest is often more difficult to use for novices.
It is necessary to become familiar with each of the tools,
to be able to use the right one in a given situation.
Additionally, one needs to combine the tools in a senseful way on its own.
This is like a sharp knife \(en it is a powerful tool in the hand of a master,
but of no good value in the hand of an unskilled.
.PP
However, learning single, small tool of the toolchest is easier than
learning a complex tool.
The user will have a basic understanding of a yet unknown tool,
if the several tools of the toolchest have a common style.
He will be able to transfer knowledge over one tool to another.
.PP
Moreover, the second drawback can be removed easily by adding wrappers
around the single tools.
Novice users do not need to learn several tools if a professional wraps
the single commands into a more high-level script.
Note that the wrapper script still calls the small tools;
the wrapper script is just like a skin around.
No complexity is added this way,
but new programs can get created out of existing one with very low effort.
.PP
A wrapper script for finding the five largest entries in the current directory
could look like this:
.DS I 2n
.CW
.ps -1
#!/bin/sh
du -s * | sort -nr | sed 5q
.DE
The script itself is just a text file that calls the command line
a professional user would type in directly.
Making the program flexible on the number of entries it prints,
is easily possible:
.DS I 2n
.CW
.ps -1
#!/bin/sh
num=5
[ $# -eq 1 ] && num="$1"
du -sh * | sort -nr | sed "${num}q"
.DE
This script acts like the one before, when called without an argument.
But one can also specify a numerical argument to define the number of lines to print.

.NH 2
A powerful shell
.LP
It was already said, that the Unix shell provides the possibility to
combine small programs into large ones easily.
A powerful shell is a great feature in other ways, too.
.PP
For instance by including a scripting language.
The control statements are build into the shell.
The functions, however, are the normal programs, everyone can use on the system.
Thus, the programs are known, so learning to program in the shell is easy.
Using normal programs as functions in the shell programming language
is only possible because they are small and combinable tools in a toolchest style.
.PP
The Unix shell encourages to write small scripts out of other programs,
because it is so easy to do.
This is a great step towards automation.
It is wonderful if the effort to automate a task equals the effort
it takes to do it the second time by hand.
If it is so, then the user will be happy to automate everything he does more than once.
.PP
Small programs that do one job well, standardized interfaces between them,
a mechanism to combine parts to larger parts, and an easy way to automate tasks,
this will inevitably produce software leverage.
Getting multiple times the benefit of an investment is a great offer.
.PP
The shell also encourages rapid prototyping.
Many well known programs started as quickly hacked shell scripts,
and turned into ``real'' programs, written in C, later.
Building a prototype first is a way to avoid the biggest problems
in application development.
Fred Brooks writes in ``No Silver Bullet'':
.[
%A Frederick P. Brooks, Jr.
%T No Silver Bullet: Essence and Accidents of Software Engineering
%B Information Processing 1986, the Proceedings of the IFIP Tenth World Computing Conference
%E H.-J. Kugler
%D 1986
%P 1069\(en1076
%I Elsevier Science B.V.
%C Amsterdam, The Netherlands
.]
.QP
The hardest single part of building a software system is deciding precisely what to build.
No other part of the conceptual work is so difficult as establishing the detailed
technical requirements, [...].
No other part of the work so cripples the resulting system if done wrong.
No other part is more difficult to rectify later.
.PP
Writing a prototype is a great method to become familiar with the requirements
and to actually run into real problems.
Today, prototyping is often seen as a first step in building a software.
This is, of course, good.
However, the Unix Philosophy has an \fIadditional\fP perspective on prototyping:
After having built the prototype, one might notice, that the prototype is already
\fIgood enough\fP.
Hence, no reimplementation, in a more sophisticated programming language, might be of need,
for the moment.
Maybe later, it might be neccessary to rewrite the software, but not now.
.PP
By delaying further work, one keeps the flexibility to react easily on
changing requirements.
Software parts that are not written will not miss the requirements.

.NH 2
Worse is better
.LP
The Unix Philosophy aims for the 80% solution;
others call it the ``Worse is better'' approach.
.PP
First, practical experience shows, that it is almost never possible to define the
requirements completely and correctly the first time.
Hence one should not try to; it will fail anyway.
Second, practical experience shows, that requirements change during time.
Hence it is best to delay requirement-based design decisions as long as possible.
Also, the software should be small and flexible as long as possible
to react on changing requirements.
Shell scripts, for example, are more easily adjusted as C programs.
Third, practical experience shows, that maintenance is hard work.
Hence, one should keep the amount of software as small as possible;
it should just fulfill the \fIcurrent\fP requirements.
Software parts that will be written later, do not need maintenance now.
.PP
Starting with a prototype in a scripting language has several advantages:
.IP \(bu
As the initial effort is low, one will likely start right away.
.IP \(bu
As working parts are available soon, the real requirements can get identified soon.
.IP \(bu
When a software is usable, it gets used, and thus tested.
Hence problems will be found at early stages of the development.
.IP \(bu
The prototype might be enough for the moment,
thus further work on the software can be delayed to a time
when one knows better about the requirements and problems,
than now.
.IP \(bu
Implementing now only the parts that are actually needed now,
requires fewer maintenance work.
.IP \(bu
If the global situation changes so that the software is not needed anymore,
then less effort was spent into the project, than it would have be
when a different approach had been used.

.NH 2
Upgrowth and survival of software
.LP
So far it was talked about \fIwriting\fP or \fIbuilding\fP software.
Although these are just verbs, they do imply a specific view on the work process
they describe.
The better verb, however, is to \fIgrow\fP.
.PP
Creating software in the sense of the Unix Philosophy is an incremental process.
It starts with a first prototype, which evolves as requirements change.
A quickly hacked shell script might become a large, sophisticated,
compiled program this way.
Its lifetime begins with the initial prototype and ends when the software is not used anymore.
While being alive it will get extended, rearranged, rebuilt (from scratch).
Growing software matches the view that ``software is never finished. It is only released.''
.[
%O FIXME
%A Mike Gancarz
%T The UNIX Philosophy
%P 26
.]
.PP
Software can be seen as being controlled by evolutionary processes.
Successful software is software that is used by many for a long time.
This implies that the software is needed, useful, and better than alternatives.
Darwin talks about: ``The survival of the fittest.''
.[
%O FIXME
%A Charles Darwin
.]
Transferred to software: The most successful software, is the fittest,
is the one that survives.
(This may be at the level of one creature, or at the level of one species.)
The fitness of software is affected mainly by four properties:
portability of code, portability of data, range of usability, and reusability of parts.
.\" .IP \(bu
.\" portability of code
.\" .IP \(bu
.\" portability of data
.\" .IP \(bu
.\" range of usability
.\" .IP \(bu
.\" reuseability of parts
.PP
(1)
.I "Portability of code
means, using high-level programming languages,
sticking to the standard,
and avoiding optimizations that introduce dependencies on specific hardware.
Hardware has a much lower lifetime than software.
By chaining software to a specific hardware,
the software's lifetime gets shortened to that of this hardware.
In contrast, software should be easy to port \(en
adaption is the key to success.
.\" cf. practice of prog: ch08
.PP
(2)
.I "Portability of data
is best achieved by avoiding binary representations
to store data, because binary representations differ from machine to machine.
Textual represenation is favored.
Historically, ASCII was the charset of choice.
In the future, UTF-8 might be the better choice, however.
Important is that it is a plain text representation in a
very common charset encoding.
Apart from being able to transfer data between machines,
readable data has the great advantage, that humans are able
to directly edit it with text editors and other tools from the Unix toolchest.
.\" gancarz tenet 5
.PP
(3)
A large
.I "range of usability
ensures good adaption, and thus good survival.
It is a special distinction if a software becomes used in fields of action,
the original authors did never imagine.
Software that solves problems in a general way will likely be used
for all kinds of similar problems.
Being too specific limits the range of uses.
Requirements change through time, thus use cases change or even vanish.
A good example in this point is Allman's sendmail.
Allman identifies flexibility to be one major reason for sendmail's success:
.[
%O FIXME
%A Allman
%T sendmail
.]
.QP
Second, I limited myself to the routing function [...].
This was a departure from the dominant thought of the time, [...].
.QP
Third, the sendmail configuration file was flexible enough to adopt
to a rapidly changing world [...].
.LP
Successful software adopts itself to the changing world.
.PP
(4)
.I "Reuse of parts
is even one step further.
A software may completely lose its field of action,
but parts of which the software is build may be general and independent enough
to survive this death.
If software is build by combining small independent programs,
then there are parts readily available for reuse.
Who cares if the large program is a failure,
but parts of it become successful instead?

.NH 2
Summary
.LP
This chapter explained the central ideas of the Unix Philosophy.
For each of the ideas, it was exposed what advantages they introduce.
The Unix Philosophy are guidelines that help to write valuable software.
From the view point of a software developer or software designer,
the Unix Philosophy provides answers to many software design problem.
.PP
The various ideas of the Unix Philosophy are very interweaved
and can hardly be applied independently.
However, the probably most important messages are:
.I "``Do one thing well!''" ,
.I "``Keep it simple!''" ,
and
.I "``Use software leverage!''



.NH 1
Case study: nmh
.LP
The last chapter introduced and explained the Unix Philosophy
from a general point of view.
The driving force were the guidelines and references to
existing software were given only sparsely.
In this and the next chapter, concrete software will be
the driving force in the discussion.
.PP
This first case study is about the mail user agents \s-1MH\s0
(``mail handler'') and its descendent \fInmh\fP (``new mail handler'').


.NH 2
History of \s-1MH\s0
.LP
In 1977, Stockton Gaines and Norman Shapiro of the \s-1RAND\s0 Corporation
came up with a concept for a new electronic mail system.
Till then, \s-1RAND\s0 had used \s-1MS\s0 (``mail system''),
which was monolithic.
In 1978 and 1989, Bruce Borden implemented the concept \(en
this was the birth of \s-1MH\s0.
.PP
Since then, \s-1RAND\s0, the University of California at Irvine and
at Berkeley, and several others have contributet to the software.
However, it's core concepts remained the same.
In the 90s, the development of \s-1MH\s0 slowed down.
Richard Coleman started with \fInmh\fP, the new mail handler,
in 1997 to improve \s-1MH\s0, especially in regard of modern emailing.
Today, nmh is developed by various people on the internet.
.[
%T RAND and the Information Evolution: A History in Essays and Vignettes
%A Willis H. Ware 
%D 2008
%I The RAND Corporation
%P 128\(en137
%O .CW \s-1http://www.rand.org/pubs/corporate_pubs/CP537/
.]
.[
%T MH & xmh: Email for Users & Programmers
%A Jerry Peek
%D 1991, 1992, 1995
%I O'Reilly & Associates, Inc.
%P Appendix B
%O Also available online: \f(CW\s-2http://rand-mh.sourceforge.net/book/\fP
.]

.NH 2
Contrasts to similar sw
.LP
vs. Thunderbird, mutt, mailx, pine
.LP
flexibility, no redundancy, use the shell

.NH 2
Gains of the design
.LP

.NH 2
Problems
.LP



.NH 1
Case study: uzbl

.NH 2
History
.LP
uzbl is young

.NH 2
Contrasts to similar sw
.LP
like with nmh
.LP
addons, plugins, modules

.NH 2
Gains of the design
.LP

.NH 2
Problems
.LP
broken web



.NH 1
Final thoughts

.NH 2
Quick summary
.LP
good design
.LP
unix phil
.LP
case studies

.NH 2
Why people should choose
.LP
Make the right choice!

.nr PI .5i
.rm ]<
.de ]<
.LP
.de FP
.IP \\\\$1.
\\..
.rm FS FE
..
.SH
References
.[
$LIST$
.]
.wh -1p
